const Command = require("../../base/Command"),
	Discord = require("discord.js");

class Someone extends Command {
	constructor(client) {
		super(client, {
			name: "someone",
			dirname: __dirname,
			enabled: false,
			guildOnly: true,
			aliases: ["somebody"],
			memberPermissions: [],
			botPermissions: ["SEND_MESSAGES", "EMBED_LINKS"],
			nsfw: false,
			ownerOnly: false,
			cooldown: 1000
		});
	}

	async run(message, args, data) {
		const member = message.guild.members.cache.random(1)[0];

		const embed = new Discord.MessageEmbed()
			.addField(message.translate("common:USERNAME"), member.user.username, true)
			.addField(message.translate("common:DISCRIMINATOR"), member.user.discriminator, true)
			.addField(message.translate("common:ID"), member.user.id, true)
			.setThumbnail(member.user.displayAvatarURL({
				size: 512,
				dynamic: true,
				format: "png"
			}))
			.setColor(data.config.embed.color);
		message.channel.send({
			embeds: [embed]
		});
	}
}

module.exports = Someone;